import React from 'react';
import styled from 'styled-components';

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

var Colors = {
  black: '#000',
  white: '#fff',
  grey: '#707070',
  greyLight: '#a9a9a9',
  away: '#FF9800',
  danger: '#ce4e4e',
  success: '#8fd16a',
  warning: '#f8dd50',
  primary: '#8fd16a',
  secundary: '#59bec9'
};
var lighten = function lighten(hex, amt) {
  var usePound = false;

  if (hex[0] === '#') {
    hex = hex.slice(1);
    usePound = true;
  }

  var num = parseInt(hex, 16);
  var r = (num >> 16) + amt;
  if (r > 255) r = 255;else if (r < 0) r = 0;
  var b = (num >> 8 & 0x00ff) + amt;
  if (b > 255) b = 255;else if (b < 0) b = 0;
  var g = (num & 0x0000ff) + amt;
  if (g > 255) g = 255;else if (g < 0) g = 0;
  return (usePound ? '#' : '') + (g | b << 8 | r << 16).toString(16);
};
var darken = function darken(hex, amt) {
  var usePound = false;

  if (hex[0] === '#') {
    hex = hex.slice(1);
    usePound = true;
  }

  var num = parseInt(hex, 16);
  var r = (num >> 16) - amt;

  if (r > 255) {
    r = 255;
  } else if (r < 0) {
    r = 0;
  }

  var b = (num >> 8 & 0x00ff) - amt;

  if (b > 255) {
    b = 255;
  } else if (b < 0) {
    b = 0;
  }

  var g = (num & 0x0000ff) - amt;

  if (g > 255) {
    g = 255;
  } else if (g < 0) {
    g = 0;
  }

  return (usePound ? '#' : '') + (g | b << 8 | r << 16).toString(16);
};

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n\tbackground-color: ", ";\n\tborder: 2px solid;\n\tborder-color: ", ";\n\tborder-radius: 12px;\n\tcolor: ", ";\n\tcursor: pointer;\n\tdisplay: block;\n\tfont-size: 16px;\n\tfont-weight: 500;\n\tline-height: 1;\n\tmargin: ", "px;\n\tmargin-bottom: ", "px;\n\tmargin-top: ", "px;\n\tpadding: 12px;\n\ttext-align: center;\n\ttext-transform: ", ";\n\ttransition: 0.15s ease-in-out;\n\twidth: ", ";\n\n\t&:hover {\n\t\tbackground-color: transparent;\n\t\tcolor: ", ";\n\t}\n\n\t", "\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var Btn = styled.button(_templateObject(), function (props) {
  return props.primary ? Colors.primary : Colors.greyLight;
}, function (props) {
  return props.primary ? Colors.primary : Colors.greyLight;
}, Colors.white, function (props) {
  return props.mg && props.mg;
}, function (props) {
  return props.mgBottom && props.mgBottom;
}, function (props) {
  return props.mgTop && props.mgTop;
}, function (props) {
  return props.uppercase && 'uppercase';
}, function (props) {
  return props.width ? props.width : '100%';
}, Colors.grey, function (_ref) {
  var type = _ref.type;
  return type && getType(type);
});

function getType(value) {
  if (!value) return;

  switch (value) {
    case 'primary':
      return "\n\t\t\t\tbackground-color: " + Colors.primary + ";\n\t\t\t\tborder-color: " + Colors.primary + ";\n\t\t\t\tcolor: " + Colors.white + ";\n\n\t\t\t\t&:hover {\n\t\t\t\t\tbackground-color: " + lighten(Colors.primary, 20) + ";\n\t\t\t\t\tborder-color: " + lighten(Colors.primary, 20) + ";\n\t\t\t\t\tcolor: " + Colors.white + ";\n\t\t\t\t}\n\t\t\t";

    case 'secundary':
      return "\n\t\t\t\tbackground-color: " + Colors.secundary + ";\n\t\t\t\tborder-color: " + Colors.secundary + ";\n\t\t\t\tcolor: " + Colors.white + ";\n\n\t\t\t\t&:hover {\n\t\t\t\t\tbackground-color: " + darken(Colors.secundary, 20) + ";\n\t\t\t\t\tborder-color: " + darken(Colors.secundary, 20) + ";\n\t\t\t\t\tcolor: " + Colors.white + ";\n\t\t\t\t}\n\t\t\t";
  }
}

var Button = function Button(_ref) {
  var type = _ref.type,
      onClick = _ref.onClick,
      children = _ref.children,
      mg = _ref.mg,
      mgBottom = _ref.mgBottom,
      mgTop = _ref.mgTop,
      uppercase = _ref.uppercase,
      width = _ref.width;
  return /*#__PURE__*/React.createElement(Btn, {
    type: type,
    onClick: onClick,
    mg: mg,
    mgBottom: mgBottom,
    mgTop: mgTop,
    uppercase: uppercase,
    width: width
  }, children);
};

export { Button };
//# sourceMappingURL=index.modern.js.map
